



#include <avr/sleep.h>
#include <avr/power.h>
#include <avr/interrupt.h>
//-#include <sleep_bod_disable.h>


#define F_CPU 1000000
#define TWI_FREQ 25000

#include <Wire3.h>

#include <digitalWriteFast.h>

extern void __builtin_avr_delay_cycles(unsigned long __n);

#define pin_led 13
#define pin_sensor_power 10
#define pin_tx_power 7
#define pin_tx_data 6


int mode_speed=1;  // bigger == slower
int mode_slowspeed=5;
int mode_count=0;
int mode_switch=15; // after mode_count equals this switch to slow mode
int mode_slow=0;     // true when in slow mode


#define SLOWCLOCK clock_div_8

#define CLOCKFIX(t) (((t)+(1<<SLOWCLOCK)-1)/(1<<SLOWCLOCK))

//#define delayMicroseconds2(t) (__builtin_avr_delay_cycles((t)*(F_CPU/(1000000*(1<<SLOWCLOCK)))))

#define delayMicroseconds2(t) (__builtin_avr_delay_cycles((t)))

unsigned int tickcount;

void slow_clock(void)
{
  
 noInterrupts ();
// CLKPR = bit (CLKPCE);
// CLKPR = SLOWCLOCK;
// interrupts ();
 
}

void fast_clock(void)
{
  
// noInterrupts ();
// CLKPR = bit (CLKPCE);
// CLKPR = clock_div_1;
 interrupts ();
 
}




/**********************************************************
 Bosch Pressure Sensor BMP085 / BMP180 readout routine
 for the Arduino platform.
  
 Compiled by Leo Nutz
 www.ALTDuino.de              
**********************************************************/



#define ADDRESS_SENSOR 0x77                 // Sensor address

int16_t  ac1, ac2, ac3, b1, b2, mb, mc, md; // Store sensor PROM values from BMP180
uint16_t ac4, ac5, ac6;                     // Store sensor PROM values from BMP180
// Ultra Low Power       OSS = 0, OSD =  5ms
// Standard              OSS = 1, OSD =  8ms
// High                  OSS = 2, OSD = 14ms
// Ultra High Resolution OSS = 3, OSD = 26ms
const uint8_t oss = 3;                      // Set oversampling setting
const uint8_t osd = 26;                     // with corresponding oversampling delay 

float T, P;                                 // Set global variables for temperature and pressure 




void sensor_loop()
{
 int32_t b5;

 b5 = temperature();                       // Read and calculate temperature (T) 

/*
 Serial.print("Temperature: ");
 Serial.print(T, 2);
 Serial.print(" C, ");
 Serial.print(1.8 * T + 32.0, 2);
 Serial.print(" F b5=");
 Serial.println(b5);
*/ 

 P = pressure(b5);                         // Read and calculate pressure (P) 

/*
 Serial.print("Pressure: ");
 Serial.print(P, 2);
 Serial.print(" mbar, ");
 Serial.print(P * 0.0295299830714, 2);
 Serial.println(" inHg ");
 Serial.println("");

 delay(500);                               // Delay between each readout
 */
}

/**********************************************
 Initialize sensor variables
**********************************************/
void init_SENSOR()
{
 ac1 = read_2_bytes(0xAA);
 ac2 = read_2_bytes(0xAC);
 ac3 = read_2_bytes(0xAE);
 ac4 = read_2_bytes(0xB0);
 ac5 = read_2_bytes(0xB2);
 ac6 = read_2_bytes(0xB4);
 b1  = read_2_bytes(0xB6);
 b2  = read_2_bytes(0xB8);
 mb  = read_2_bytes(0xBA);
 mc  = read_2_bytes(0xBC);
 md  = read_2_bytes(0xBE);
/*
 Serial.println("");
 Serial.println("Sensor calibration data:");
 Serial.print(F("AC1 = ")); Serial.println(ac1);
 Serial.print(F("AC2 = ")); Serial.println(ac2);
 Serial.print(F("AC3 = ")); Serial.println(ac3);
 Serial.print(F("AC4 = ")); Serial.println(ac4);
 Serial.print(F("AC5 = ")); Serial.println(ac5);
 Serial.print(F("AC6 = ")); Serial.println(ac6);
 Serial.print(F("B1 = "));  Serial.println(b1);
 Serial.print(F("B2 = "));  Serial.println(b2);
 Serial.print(F("MB = "));  Serial.println(mb);
 Serial.print(F("MC = "));  Serial.println(mc);
 Serial.print(F("MD = "));  Serial.println(md);
 Serial.println("");
 */
}

/**********************************************
 Calcualte pressure readings
**********************************************/
float pressure(int32_t b5)
{
 int32_t x1, x2, x3, b3, b6, p, UP;
 uint32_t b4, b7; 

 UP = read_pressure();                         // Read raw pressure

 b6 = b5 - 4000;
 x1 = (b2 * (b6 * b6 >> 12)) >> 11; 
 x2 = ac2 * b6 >> 11;
 x3 = x1 + x2;
 b3 = (((ac1 * 4 + x3) << oss) + 2) >> 2;
 x1 = ac3 * b6 >> 13;
 x2 = (b1 * (b6 * b6 >> 12)) >> 16;
 x3 = ((x1 + x2) + 2) >> 2;
 b4 = (ac4 * (uint32_t)(x3 + 32768)) >> 15;
 b7 = ((uint32_t)UP - b3) * (50000 >> oss);
 if(b7 < 0x80000000) { p = (b7 << 1) / b4; } else { p = (b7 / b4) << 1; } // or p = b7 < 0x80000000 ? (b7 * 2) / b4 : (b7 / b4) * 2;
 x1 = (p >> 8) * (p >> 8);
 x1 = (x1 * 3038) >> 16;
 x2 = (-7357 * p) >> 16;
 return (p + ((x1 + x2 + 3791) >> 4)) / 100.0f; // Return pressure in mbar
}

/**********************************************
 Read uncompensated temperature
**********************************************/
int32_t temperature()
{
 int32_t x1, x2, b5, UT;

 Wire.beginTransmission(ADDRESS_SENSOR); // Start transmission to device 
 Wire.write(0xf4);                       // Sends register address
 Wire.write(0x2e);                       // Write data
 Wire.endTransmission();                 // End transmission
 delay(CLOCKFIX(5));                               // Datasheet suggests 4.5 ms
 
 UT = read_2_bytes(0xf6);                // Read uncompensated TEMPERATURE value

 // Calculate true temperature
 x1 = (UT - (int32_t)ac6) * (int32_t)ac5 >> 15;
 x2 = ((int32_t)mc << 11) / (x1 + (int32_t)md);
 b5 = x1 + x2;
 T  = (b5 + 8) >> 4;
 T = T / 10.0;                           // Temperature in celsius 
 return b5;  
}

/**********************************************
 Read uncompensated pressure value
**********************************************/
int32_t read_pressure()
{
 int32_t value; 
 Wire.beginTransmission(ADDRESS_SENSOR);   // Start transmission to device 
 Wire.write(0xf4);                         // Sends register address to read from
 Wire.write(0x34 + (oss << 6));            // Write data
 Wire.endTransmission();                   // SEd transmission
 delay(CLOCKFIX(osd));                               // Oversampling setting delay
 Wire.beginTransmission(ADDRESS_SENSOR);
 Wire.write(0xf6);                         // Register to read
 Wire.endTransmission();
 Wire.requestFrom(ADDRESS_SENSOR, 3);      // Request three bytes
 if(Wire.available() >= 3)
 {
   value = (((int32_t)Wire.read() << 16) | ((int32_t)Wire.read() << 8) | ((int32_t)Wire.read())) >> (8 - oss);
 }
 return value;                             // Return value
}

/**********************************************
 Read 1 byte from the BMP sensor
**********************************************/
uint8_t read_1_byte(uint8_t code)
{
 uint8_t value;
 Wire.beginTransmission(ADDRESS_SENSOR);         // Start transmission to device 
 Wire.write(code);                               // Sends register address to read from
 Wire.endTransmission();                         // End transmission
 Wire.requestFrom(ADDRESS_SENSOR, 1);            // Request data for 1 byte to be read
 if(Wire.available() >= 1)
 {
   value = Wire.read();                          // Get 1 byte of data
 }
 return value;                                   // Return value
}

/**********************************************
 Read 2 bytes from the BMP sensor
**********************************************/
uint16_t read_2_bytes(uint8_t code)
{
 uint16_t value;
 Wire.beginTransmission(ADDRESS_SENSOR);         // Start transmission to device 
 Wire.write(code);                               // Sends register address to read from
 Wire.endTransmission();                         // End transmission
 Wire.requestFrom(ADDRESS_SENSOR, 2);            // Request 2 bytes from device
 if(Wire.available() >= 2)
 {
   value = (Wire.read() << 8) | Wire.read();     // Get 2 bytes of data
 }
 return value;                                   // Return value
}














/*
 * connectingStuff, Oregon Scientific v2.1 Emitter
 * http://connectingstuff.net/blog/encodage-protocoles-oregon-scientific-sur-arduino/
 *
 * Copyright (C) 2013 olivier.lebrun@gmail.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/


void writeBCD(byte * p,int nybble,int width,long value)
{
 char buffer[16]; 
 char fmt[8];
 int  byteindex=nybble/2;
 int  i;
 int  c;

 nybble=nybble-byteindex*2; 
  
  
// Serial.println(value); 

 sprintf(fmt,"%%0%dd",width); 
 sprintf(buffer,fmt,value);

// Serial.println(buffer);


 for(i=0;i<width;i++)
 {
  c=buffer[i]-'0';
//   Serial.println(c);
  if(nybble & 0x1)
  {
   p[byteindex]=(p[byteindex] & 0xF0) | c;
   nybble=0;
   byteindex++;
  }
  else
  {
   p[byteindex]=(p[byteindex] & 0xF) | (c<<4);
   nybble++;
  } 
 } 
}





const unsigned long TIME = (512);
const unsigned long TWOTIME = (1024);
 
//#define SEND_HIGH() digitalWrite(pin_tx_data, 1)
//#define SEND_LOW() digitalWrite(pin_tx_data, 0)


#define SEND_HIGH() digitalWriteFast2(pin_tx_data, 1)
#define SEND_LOW() digitalWriteFast2(pin_tx_data, 0)



 
// Buffer for Oregon message
  byte OregonMessageBuffer[9];

 
/**
 * \brief    Send logical "0" over RF
 * \details  azero bit be represented by an off-to-on transition
 * \         of the RF signal at the middle of a clock period.
 * \         Remenber, the Oregon v2.1 protocol add an inverted bit first 
 */
inline void sendZero(void) 
{
  SEND_HIGH();
  delayMicroseconds2(TIME);
//  pulse(TIME,HIGH);
  SEND_LOW();
  delayMicroseconds2(TWOTIME);
//  pulse(TWOTIME,LOW);
  SEND_HIGH();
  delayMicroseconds2(TIME);
//  pulse(TIME,HIGH);  
}
 
/**
 * \brief    Send logical "1" over RF
 * \details  a one bit be represented by an on-to-off transition
 * \         of the RF signal at the middle of a clock period.
 * \         Remenber, the Oregon v2.1 protocol add an inverted bit first 
 */
inline void sendOne(void) 
{
   SEND_LOW();
   delayMicroseconds2(TIME);
//   pulse(TIME,LOW);   
   SEND_HIGH();
   delayMicroseconds2(TWOTIME);
//   pulse(TWOTIME,HIGH);   
   SEND_LOW();
   delayMicroseconds2(TIME);
//   pulse(TIME,LOW);   
}
 
/**
* Send a bits quarter (4 bits = MSB from 8 bits value) over RF
*
* @param data Source data to process and sent
*/
 
/**
 * \brief    Send a bits quarter (4 bits = MSB from 8 bits value) over RF
 * \param    data   Data to send
 */
inline void sendQuarterMSB(const byte data) 
{
  (bitRead(data, 4)) ? sendOne() : sendZero();
  (bitRead(data, 5)) ? sendOne() : sendZero();
  (bitRead(data, 6)) ? sendOne() : sendZero();
  (bitRead(data, 7)) ? sendOne() : sendZero();
}
 
/**
 * \brief    Send a bits quarter (4 bits = LSB from 8 bits value) over RF
 * \param    data   Data to send
 */
inline void sendQuarterLSB(const byte data) 
{
  (bitRead(data, 0)) ? sendOne() : sendZero();
  (bitRead(data, 1)) ? sendOne() : sendZero();
  (bitRead(data, 2)) ? sendOne() : sendZero();
  (bitRead(data, 3)) ? sendOne() : sendZero();
}
 
/******************************************************************/
/******************************************************************/
/******************************************************************/
 
/**
 * \brief    Send a buffer over RF
 * \param    data   Data to send
 * \param    size   size of data to send
 */
void sendData(byte *data, byte size)
{
  for(byte i = 0; i < size; ++i)
  {
    sendQuarterLSB(data[i]);
    sendQuarterMSB(data[i]);
  }
}
 
/**
 * \brief    Send an Oregon message
 * \param    data   The Oregon message
 */
void sendOregon(byte *data, byte size)
{
    sendPreamble();
    //sendSync();
    sendData(data, size);
    sendPostamble();
}
 
/**
 * \brief    Send preamble
 * \details  The preamble consists of 16 "1" bits
 */
inline void sendPreamble(void)
{
  byte PREAMBLE[]={0xFF,0xFF,0xff,0xff};
  sendData(PREAMBLE, 3); // changed from 2 - 16 bits goes to 24
}
 
/**
 * \brief    Send postamble
 * \details  The postamble consists of 8 "0" bits
 */
inline void sendPostamble(void)
{
  byte POSTAMBLE[]={0x00};
  sendData(POSTAMBLE, 1);  

}
 
/**
 * \brief    Send sync nibble
 * \details  The sync is 0xA. It is not use in this version since the sync nibble
 * \         is include in the Oregon message to send.
 */
inline void sendSync(void)
{
  sendQuarterLSB(0xA);
}
 
/******************************************************************/
/******************************************************************/
/******************************************************************/
 
/**
 * \brief    Set the sensor type
 * \param    data       Oregon message
 * \param    type       Sensor type
 */
inline void setType(byte *data, byte* type) 
{
  data[0] = type[0];
  data[1] = type[1];
}
 
/**
 * \brief    Set the sensor channel
 * \param    data       Oregon message
 * \param    channel    Sensor channel (0x10, 0x20, 0x30)
 */
inline void setChannel(byte *data, byte channel) 
{
    data[2] = channel;
}
 
/**
 * \brief    Set the sensor ID
 * \param    data       Oregon message
 * \param    ID         Sensor unique ID
 */
inline void setId(byte *data, byte ID) 
{
  data[3] = ID;
}
 
/**
 * \brief    Set the sensor battery level
 * \param    data       Oregon message
 * \param    level      Battery level (0 = low, 1 = high)
 */
void setBatteryLevel(byte *data, byte level)
{
  if(!level) data[4] = 0x0C;
  else data[4] = 0x00;
}
 
/**
 * \brief    Set the sensor temperature
 * \param    data       Oregon message
 * \param    temp       the temperature
 */
void setTemperature(byte *data, float temp) 
{
  // Set temperature sign
  if(temp < 0)
  {
    data[6] = 0x08;
    temp *= -1;  
  }
  else
  {
    data[6] = 0x00;
  }
 
  // Determine decimal and float part
  int tempInt = (int)temp;
  int td = (int)(tempInt / 10);
  int tf = (int)round((float)((float)tempInt/10 - (float)td) * 10);
 
  int tempFloat =  (int)round((float)(temp - (float)tempInt) * 10);
 
  // Set temperature decimal part
  data[5] = (td << 4);
  data[5] |= tf;
 
  // Set temperature float part
  data[4] |= (tempFloat << 4);
}
 
/**
 * \brief    Set the sensor humidity
 * \param    data       Oregon message
 * \param    hum        the humidity
 */
void setHumidity(byte* data, byte hum)
{
    data[7] = (hum/10);
    data[6] |= (hum - data[7]*10) << 4;
}
 
/**
 * \brief    Sum data for checksum
 * \param    count      number of bit to sum
 * \param    data       Oregon message
 */
int Sum(byte count, const byte* data)
{
  int s = 0;
 
  for(byte i = 0; i<count;i++)
  {
    s += (data[i]&0xF0) >> 4;
    s += (data[i]&0xF);
  }
 
  if(int(count) != count)
    s += (data[count]&0xF0) >> 4;
 
  return s;
}
 
/**
 * \brief    Calculate checksum
 * \param    data       Oregon message
 */
void calculateAndSetChecksum(byte* data)
{
 data[8] = ((Sum(8, data) - 0xa) & 0xFF);
}



void transmitter_send(void)
{
 // calculateAndSetChecksum(OregonMessageBuffer);
 
//  Serial.println("send message");
// Show the Oregon Message
/*
  for (byte i = 0; i < sizeof(OregonMessageBuffer); ++i)   
  {
    Serial.print(OregonMessageBuffer[i] >> 4, HEX);
    Serial.print(OregonMessageBuffer[i] & 0x0F, HEX);
  }
  Serial.println();
*/

  slow_clock();

//  writeBCD(OregonMessageBuffer,6,2,11);
  // Send the Message over RF

  sendOregon(OregonMessageBuffer, sizeof(OregonMessageBuffer));
  // Send a "pause"
  SEND_LOW();
//  pulse(0,LOW);
//  writeBCD(OregonMessageBuffer,6,2,22);
//  delayMicroseconds(TWOTIME*8);
  // Send a copie of the first message. The v2.1 protocol send the
  // message two time 
//  sendOregon(OregonMessageBuffer, sizeof(OregonMessageBuffer));
 
  // Wait for 30 seconds before send a new message 
//  SEND_LOW();  
 
//   writeBCD(OregonMessageBuffer,6,2,33);
//   delayMicroseconds(TWOTIME*8);

//  sendOregon(OregonMessageBuffer, sizeof(OregonMessageBuffer));
 
  // Wait for 30 seconds before send a new message 
  SEND_LOW();  

  fast_clock();
}



// https://code.google.com/p/tinkerit/wiki/SecretThermometer

long readTemp() {
  long result;
  // Read temperature sensor against 1.1V reference
  ADMUX = _BV(REFS1) | _BV(REFS0) | _BV(MUX3);
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Convert
  while (bit_is_set(ADCSRA,ADSC));
  result = ADCL;
  result |= ADCH<<8;
//  result = (result - 125) * 1075;
  return result;
}



// https://code.google.com/p/tinkerit/wiki/SecretVoltmeter

long readVcc() {
  long result;
  // Read 1.1V reference against AVcc
  ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Convert
  while (bit_is_set(ADCSRA,ADSC));
  result = ADCL;
  result |= ADCH<<8;
  result = 1126400L / result; // Back-calculate AVcc in mV
  return result;
}



/*********************************************************************************************/


void  sensor_power_up(void)
{
 pinMode(pin_sensor_power, OUTPUT);
 digitalWrite(pin_sensor_power,1);
}



void  sensor_power_down(void)
{
 digitalWrite(pin_sensor_power,0);  
 pinMode(pin_sensor_power, INPUT);
}



void sensor_setup()
{
 Wire.begin();                             // Activate I2C

 sensor_power_up(); 
 delay(2000);

 init_SENSOR();                            // Initialize baro sensor variables
 delay(100);

 sensor_power_down();
}



void transmitter_setup(void)
{
 byte ID[] = {0x1A,0xA1};
  
// pinMode(pin_tx_power , OUTPUT);
 digitalWrite(pin_tx_power, 1);
  
// pinMode(pin_tx_data , OUTPUT);
 SEND_LOW();  
//  pulse(0,LOW);
 
 setType(OregonMessageBuffer, ID);
 setChannel(OregonMessageBuffer, 0x20);
 setId(OregonMessageBuffer, 0xBB);
}


void transmitter_setdown(void)
{
 digitalWrite(pin_tx_data, 0);
// pinMode(pin_tx_data , OUTPUT);
 digitalWrite(pin_tx_power, 0);
// pinMode(pin_tx_power , OUTPUT);
}



void payload(void)
{
// for checking accuracy  
// Serial.println("*");

  
// tickcount++;  

// delay(CLOCKFIX(100));
// sensor_loop();
// sensor_power_down();
// power_twi_disable();



// long vcc=readVcc()/100;
// Serial.print("T "); 
// Serial.println(T,DEC);

// Serial.flush();

// writeBCD(OregonMessageBuffer,6,2,vcc);
 
// long temp=readTemp();
// Serial.print("Core temp ");
// Serial.println(temp,DEC);
 
 writeBCD(OregonMessageBuffer,6,2,tickcount);
 writeBCD(OregonMessageBuffer,8,2,tickcount);
 writeBCD(OregonMessageBuffer,10,2,T);
 writeBCD(OregonMessageBuffer,12,4,P); 
 

 transmitter_send();

 sensor_loop();
 sensor_power_down();
 power_twi_disable();



 if(!mode_slow)
 {
  pinMode(pin_led, OUTPUT);
  digitalWrite(pin_led, LOW);
  delay(CLOCKFIX(100));
  digitalWrite(pin_led, HIGH);
  delay(CLOCKFIX(100)); 
//  pinMode(pin_led, INPUT);
  digitalWrite(pin_led, LOW);
 }

//  Serial.flush();
}  



void power_down(void)
{
// sensor_power_down();
 transmitter_setdown(); 
 
}

void power_up(void)
{
 sensor_power_up();
 transmitter_setup();
}






#ifndef sleep_bod_disable() // not included in Arduino AVR toolset
#define sleep_bod_disable() \
do { \
  uint8_t tempreg; \
  __asm__ __volatile__("in %[tempreg], %[mcucr]" "\n\t" \
                       "ori %[tempreg], %[bods_bodse]" "\n\t" \
                       "out %[mcucr], %[tempreg]" "\n\t" \
                       "andi %[tempreg], %[not_bodse]" "\n\t" \
                       "out %[mcucr], %[tempreg]" \
                       : [tempreg] "=&d" (tempreg) \
                       : [mcucr] "I" _SFR_IO_ADDR(MCUCR), \
                         [bods_bodse] "i" (_BV(BODS) | _BV(BODSE)), \
                         [not_bodse] "i" (~_BV(BODSE))); \
} while (0)
#endif



//#define OVERFLOWMODE 1

#define CTCMODE 1

#ifdef CTCMODE
// interrupt on Timer 2 compare "A" completion - does nothing
EMPTY_INTERRUPT (TIMER2_COMPA_vect);
#endif

#ifdef OVERFLOWMODE
EMPTY_INTERRUPT(TIMER2_OVF_vect);
#endif


byte adcsra;

void power_down_lowlevel(void)
{
 adcsra = ADCSRA;                  //save the ADC Control and Status Register A
 ADCSRA = 0;
 power_adc_disable ();
 power_spi_disable();
 power_twi_disable();
 power_timer0_disable();
 power_timer1_disable();
 power_usart0_disable();
}


void power_down_lowlevel_part(void)
{
 power_twi_disable();
 power_timer0_disable();
 power_timer1_disable();
}



void power_up_lowlevel(void)
{
 power_timer0_enable();
 power_timer1_enable();
 power_usart0_enable();
 power_adc_enable();  
 ADCSRA = adcsra;
 power_spi_enable();
 power_twi_enable();  
}  


void power_up_lowlevel_part(void)
{
 power_timer0_enable();
 power_timer1_enable();
 power_twi_enable();  
}  



long next_count;


int  target_reached;
int  realtarget_period=(1*8*32);
double corr_factor=6.844178e-5;
int  remaining_count;
double error_count;

// event 400 15998905 error 1095
// event 896 35880113 error 113

void getnexttarget(void)
{
 int temp;
 
 remaining_count=realtarget_period*mode_speed;
 
 error_count+=corr_factor*(double)realtarget_period;
 temp=(int)(error_count);
 remaining_count+=temp;
 error_count-=(double)temp;
 
// Serial.print("err ");
// Serial.println(error_count);
}


void loop() 
{ 
 power_down();
  
//  Serial.println("loop");
 power_down_lowlevel_part(); 
  
 while(1)
 {
  if(remaining_count<=0)
  {
   getnexttarget();
   target_reached=1;
  }
  else
  {
   target_reached=0;    
  }

  next_count=remaining_count;

  if(next_count>256 && next_count<(256+128))
  {  
   next_count=next_count/2;
  }
  else 
  if(next_count>256)
  {
   next_count=256;
  }   
  remaining_count-=next_count;
  
#ifdef OVERFLOWMODE  
  next_count=256-next_count;
#endif

  tickcount++;
  if(tickcount>=225) tickcount=0;
 
//Serial.print("rem ");Serial.print(remaining_count);
//Serial.print(" nex ");Serial.println(next_count);
//Serial.flush();

//  power_down();
//  power_down_lowlevel();
  
  cli();
  set_sleep_mode(SLEEP_MODE_PWR_SAVE);  
  sleep_enable();
  sleep_bod_disable();
  sei();
  sleep_cpu();

#ifdef OVERFLOWMODE
    TCNT2 = next_count;
    OCR2A = 0;                        //write to OCR2A, we're not using it, but no matter
    while (ASSR & _BV(OCR2AUB)) {}    //wait for OCR2A to be updated
#endif

#ifdef CTCMODE
     OCR2A=(next_count-1);
     while (ASSR & _BV(OCR2AUB)) {}    //wait for OCR2A to be updated
   
#endif

  sleep_disable();
//   power_up_lowlevel();
  if(target_reached) break;
 }
  

 power_up_lowlevel_part();

 power_up();

 payload();

 if(mode_count++==mode_switch)
 {
  mode_speed=mode_slowspeed;
  mode_slow=1;
 }
 

}
  
  
  
  
void setup() 
{
// Serial.begin(9600);        // connect to the serial port  
// Serial.println("start up");


 CLKPR = bit (CLKPCE);
 CLKPR = SLOWCLOCK;

 for(int i=0;i<14;i++)
 {
  pinMode(i, OUTPUT);
  digitalWrite(i, LOW);
 }

 for(int i=A0;i<A4;i++)
 {
  pinMode(i, OUTPUT);
  digitalWrite(i, LOW);
 }

  
 sensor_setup();
 
 getnexttarget();

//Serial.println("setup2");

#ifdef CTCMODE  
  // clock input to timer 2 from XTAL1/XTAL2
 ASSR = bit (AS2);  

  // set up timer 2 to count up to 32 * 1024  (32768)
 TCCR2A = bit (WGM21);                             // CTC
 TCCR2B = bit (CS20) | bit (CS21) | bit (CS22);    // Prescaler of 1024                                  
 OCR2A =  255;              // count to 32 (zero-relative)                  

  // enable timer interrupts
 TIMSK2 |= bit (OCIE2A);
  
#endif

#ifdef OVERFLOWMODE

 //Set up TIMER2
    TIMSK2 = 0;                        //stop timer2 interrupts while we set up
    ASSR = _BV(AS2);                   //Timer/Counter2 clocked from external crystal
    TCCR2A = 0;                        //override arduino settings, ensure WGM mode 0 (normal mode)
    TCCR2B = _BV(CS22) | _BV(CS21) | _BV(CS20);    //prescaler clk/1024 -- TCNT2 will overflow once every 8 seconds
    TCNT2 = 0;                         //start the timer at zero
    while (ASSR & (_BV(TCN2UB) | _BV(TCR2AUB) | _BV(TCR2BUB))) {}    //wait for the registers to be updated    
    TIFR2 = _BV(OCF2B) | _BV(OCF2A) | _BV(TOV2);                     //clear the interrupt flags
    TIMSK2 = _BV(TOIE2);               //enable interrupt on overflow

#endif
  
  
  power_down_lowlevel();
  power_up_lowlevel_part();

}

  
